#ifndef POLDHU_H
#define POLDHU_H

/* Maximum cards allowed */
#define MAX_POLDHUS	4

#define POLDHU_VERSION	0xa0
/* Poldhu registers */
#define Comms(base)	(base)
#define Comms0(base)	(base)
#define Comms1(base)	(base + 0x01)
#define Comms2(base)	(base + 0x02)
#define Comms3(base)	(base + 0x03)
#define Comms4(base)	(base + 0x04)
#define Comms5(base)	(base + 0x05)
#define Comms6(base)	(base + 0x06)
#define Comms7(base)	(base + 0x07)
#define Comms8(base)	(base + 0x08)
#define Comms9(base)	(base + 0x09)
#define Comms10(base)	(base + 0x0a)

#define MAC(base)	(base + 0x00)
#define MAC0(base)	(base + 0x00)	/* MAC Address */
#define MAC1(base)	(base + 0x01)
#define MAC2(base)	(base + 0x02)
#define MAC3(base)	(base + 0x03)
#define MAC4(base)	(base + 0x04)
#define MAC5(base)	(base + 0x05)
#define VERSION(base)	(base + 0x06)
#define STATUS(base)	(base + 0x07)
#define INTR(base)	(base + 0x08)
#define RESET(base)	(base + 0x09)
#define IN(base)	(base + 0x0a)
#define OUT(base)	(base + 0x0a)

/* Comms7 */
#define RST_ACK		0x80
#define URG		0x40
#define SEQ		0x20
#define CTS		0x10
#define RST_CARD	0x08
#define INT_STATUS	0x04

/* Comms8 */
#define INT_EN		0x80

/* Comms9 */
#define RST_DRVR	0x80

/* State machine */
#define POLDHU_STATE_INIT	0
#define POLDHU_STATE_RESET	1
#define POLDHU_STATE_RECEIVE	2
#define POLDHU_STATE_STARTTX	3
#define POLDHU_STATE_SENDING	4
#define POLDHU_STATE_INT_EN	8

/* Capability info */
#define CAP_ESS		(1<<0)
#define CAP_IBSS	(1<<1)
#define CAP_PRIVACY	(1<<4)

#endif /* POLDHU_H */

